clang-tools 10.0.0

TypeMismatchCheck.h
Go to the documentation of this file.
1 //===--- TypeMismatchCheck.h - clang-tidy------------------------*- C++ -*-===//
2 //
3 // Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
4 // See https://llvm.org/LICENSE.txt for license information.
5 // SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
6 //
7 //===----------------------------------------------------------------------===//
8
9 #ifndef LLVM_CLANG_TOOLS_EXTRA_CLANG_TIDY_MPI_TYPE_MISMATCH_H
10 #define LLVM_CLANG_TOOLS_EXTRA_CLANG_TIDY_MPI_TYPE_MISMATCH_H
11
12 #include "../ClangTidyCheck.h"
13 #include "clang/ASTMatchers/ASTMatchFinder.h"
14
15 namespace clang {
16 namespace tidy {
17 namespace mpi {
18
19 /// This check verifies if buffer type and MPI (Message Passing Interface)
20 /// datatype pairs match. All MPI datatypes defined by the MPI standard (3.1)
21 /// are verified by this check. User defined typedefs, custom MPI datatypes and
22 /// null pointer constants are skipped, in the course of verification.
23 ///
24 /// For the user-facing documentation see:
25 /// http://clang.llvm.org/extra/clang-tidy/checks/mpi-type-mismatch.html
26 class TypeMismatchCheck : public ClangTidyCheck {
27 public:
28 TypeMismatchCheck(StringRef Name, ClangTidyContext *Context)
29 : ClangTidyCheck(Name, Context) {}
30
31 void registerMatchers(ast_matchers::MatchFinder *Finder) override;
32 void check(const ast_matchers::MatchFinder::MatchResult &Result) override;
33
34 private:
35 /// Check if the buffer type MPI datatype pairs match.
36 ///
37 /// \param BufferTypes buffer types
38 /// \param BufferExprs buffer arguments as expressions
39 /// \param MPIDatatypes MPI datatype
40 /// \param LO language options
41 void checkArguments(ArrayRef<const Type *> BufferTypes,
42 ArrayRef<const Expr *> BufferExprs,
43 ArrayRef<StringRef> MPIDatatypes, const LangOptions &LO);
44 };
45
46 } // namespace mpi
47 } // namespace tidy
48 } // namespace clang
49
50 #endif // LLVM_CLANG_TOOLS_EXTRA_CLANG_TIDY_MPI_TYPE_MISMATCH_H
clang::tidy::mpi::TypeMismatchCheck
This check verifies if buffer type and MPI (Message Passing Interface) datatype pairs match...
Definition: TypeMismatchCheck.h:26
clang::tidy::mpi::TypeMismatchCheck::check
void check(const ast_matchers::MatchFinder::MatchResult &Result) override
ClangTidyChecks that register ASTMatchers should do the actual work in here.
Definition: TypeMismatchCheck.cpp:243
clang::tidy::ClangTidyCheck
Base class for all clang-tidy checks.
Definition: ClangTidyCheck.h:47
Name
static constexpr llvm::StringLiteral Name
Definition: UppercaseLiteralSuffixCheck.cpp:27
clang::tidy::mpi::TypeMismatchCheck::registerMatchers
void registerMatchers(ast_matchers::MatchFinder *Finder) override
Override this to register AST matchers with Finder.
Definition: TypeMismatchCheck.cpp:239
clang
===– Representation.cpp - ClangDoc Representation --------—*- C++ -*-===//
Definition: ApplyReplacements.h:27
clang::tidy::mpi::TypeMismatchCheck::TypeMismatchCheck
TypeMismatchCheck(StringRef Name, ClangTidyContext *Context)
Definition: TypeMismatchCheck.h:28
clang::tidy::ClangTidyContext
Every ClangTidyCheck reports errors through a DiagnosticsEngine provided by this context.
Definition: ClangTidyDiagnosticConsumer.h:77